test1: exercise_05_25
	@echo "Running $@..."
	@./$< < $@.input > $@.output
	@diff $@.output $@.expected > /dev/null && echo "$@ PASSED" || echo "$@ FAILED"

exercise_05_25: exercise_05_25.o | .gitignore
	g++ -Wall -Wextra -Werror -std=c++03 -g3 -Wno-tautological-compare $^ -o $@

%.ii: %.cpp
	g++ -Wall -Wextra -Werror -std=c++03 -g3 -E -Wno-tautological-compare $< -o $@

%.s: %.ii
	g++ -Wall -Wextra -Werror -std=c++03 -g3 -S -Wno-tautological-compare $< -o $@

%.o: %.s
	g++ -Wall -Wextra -Werror -std=c++03 -g3 -c -Wno-tautological-compare $< -o $@

.gitignore:
	echo exercise_05_25 > $@

clean:
	rm -rf *.ii *.s *.o *.output exercise_05_25

.PRECIOUS: exercise_05_25.ii exercise_05_25.s
.SECONDARY: exercise_05_25.ii exercise_05_25.s

